#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdint.h>
#include <arm_neon.h>
#include <omp.h>
#include <math.h>

int main(int argc, char **argv)
{
	uint32_t i = 0;

	#pragma omp parallel
	do {
		float f = 0.0;
		memcpy(&f, &i, 4);

		float actual = sqrtf(f);
		float rsqr = 1.0 / sqrtf(f);
		float spec = 1.0 / rsqr;
		float mul = rsqr * f;
		float err_spec = fabsf(spec - actual);
		float err_mul = fabsf(mul - actual);
		assert(err_mul <= err_spec);

		++i;
	} while (i != 0);

	printf("Checked 4 billion values\n");
}
